﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Text.RegularExpressions;

namespace WindowsFormsApplication1
{
     
    public partial class Form1 : Form
    {

        public Form1()
        {
            ////////////////////////////STARTUP/////////////////////////////////
            InitializeComponent();
            this.MaximumSize = this.MinimumSize = this.Size; // For static size

            
        }
        
        private void bin_data_to_hex(byte[] data, int data_size)
        {
            int address = 0;
            int line_size = 16;
            char ch_start = ':';
            byte record_type = 0;
            Variables.hex_data = "";
            int bytes_converted = 0;
            while (bytes_converted<data_size)
            {
                byte checksum = 0;
                checksum += (byte)(line_size);
                checksum += (byte)((address>>8)&0xff);
                checksum += (byte)(address & 0xff);
                checksum += record_type;
                Variables.hex_data += ch_start;
                Variables.hex_data += line_size.ToString("X2");
                Variables.hex_data += address.ToString("X4");
                Variables.hex_data += record_type.ToString("X2");
                for (int i = 0; i < line_size; i++)
                {
                    byte ch = 0xff; // ensure padding with 0xff.
                    if (bytes_converted < data_size)
                    {
                        ch = data[bytes_converted];
                    }
                    checksum += ch;
                    Variables.hex_data += ch.ToString("X2");
                    bytes_converted += 1;
                }
                checksum ^= 0xff;
                checksum += 1;
                Variables.hex_data += checksum.ToString("X2");
                Variables.hex_data += "\r\n";
                address += line_size;
            }
            // Terminate with End Of File record.
            Variables.hex_data += ":00000001FF\r\n";
        }

        private bool load_sigmastudio_hex_file()
        {
            // Read the file and convert it to binary.
            // According to the datasheet of the ADAU1701, it will need no more than 9248 bytes.
            // A line looks like this:
            // 0x01 , 0x00 , 0x05 , 0x00 , 0x08 , 0x1C , 0x00 , 0x58 ,<CR><LF>
            StreamReader streamReader = new StreamReader(Variables.FullPathAndName);
            Variables.bin_data_index = 0;
            string line;
            textBox4.Text = "";
            do
            {
                line = streamReader.ReadLine();
                if (line != null)
                {
                    textBox4.AppendText(line + "\r\n");
                    line = line.Replace(" ", "");
                    line = line.Replace("0x", "");
                    line = line.Replace(",", "");
                    for (int i = 0; i < line.Length; i += 2)
                    {
                        Variables.bin_data[Variables.bin_data_index] = hex_to_bin2(line[i], line[i + 1]);
                        Variables.bin_data_index += 1;
                        if (Variables.bin_data_index >= Variables.max_file_size)
                        {
                            MessageBox.Show("File too large, aborting");
                            Variables.bin_data_index = 0;
                            return false;
                        }
                    }
                }
            }
            while (line != null);
            streamReader.Close();
            return true;
        }

        private void BROWSE_Click(object sender, EventArgs e)
        {
            //BROWSE FOR FILE BUTTON
            
            OpenFileDialog browse = new OpenFileDialog();
            browse.Title = "Open File";
            browse.Filter = "SigmaStudio Output (.Hex)|E2Prom.Hex"; // Only allow "E2Prom.Hex"
            browse.FilterIndex = 1;
            browse.RestoreDirectory = true;
            if (browse.ShowDialog() == DialogResult.OK)
            {
                string FullPathAndFilename = browse.FileName;
                Variables.FullPathAndName = FullPathAndFilename;
                
                textBox2.Text = Variables.FullPathAndName;
                string FullPathAndFilenameTemp = FullPathAndFilename.Replace(".Hex", "_converted.hex");
                load_sigmastudio_hex_file();
                // Create Intel HEX file.
                bin_data_to_hex(Variables.bin_data,Variables.bin_data_index);
    
                Variables.FullPathAndNameDest = FullPathAndFilenameTemp;
                textBox3.Text = Variables.FullPathAndNameDest;

                textBox1.Text= Variables.hex_data;
                Variables.STATE = "SigmaStudio Hex file loaded";
                stateDisplay.Text = Variables.STATE;
                Variables.HexImported = false;

                                
            }
            else
            {
                Variables.STATE = "Error opening file";
                stateDisplay.Text = Variables.STATE;
            }
        }

        public byte hex_to_bin(char ch)
        {
            // Assumes uppercase characters.
            if (ch > '9') return (byte)(ch - 'A' + 10);
            else return (byte)(ch - '0');
        }

        public byte hex_to_bin2(char ch1, char ch2)
        {
            byte value = hex_to_bin(ch1);
            value <<= 4;
            value += hex_to_bin(ch2);
            return value;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (Variables.hex_data != null)
            {

                SaveFileDialog dialog = new SaveFileDialog();
                dialog.Title = "Save file as...";
                dialog.Filter = "HEX files (*.hex)|*.hex|All files (*.*)|*.*";
                dialog.FileName = Path.GetFileName(Variables.FullPathAndNameDest);
                dialog.RestoreDirectory = true;

                if (dialog.ShowDialog() == DialogResult.OK)
                {
                    Variables.FullPathAndNameDest = dialog.FileName;
                    textBox3.Text = Variables.FullPathAndNameDest;


                    // Write file
                    File.WriteAllText(Variables.FullPathAndNameDest, Variables.hex_data);

                    // Read back written file for verification.


                    StreamReader streamReader = new StreamReader(Variables.FullPathAndNameDest);

                    string hex_data_readback = streamReader.ReadToEnd();
                    streamReader.Close();

                    if (hex_data_readback == Variables.hex_data)
                    {
                        //MessageBox.Show("File written to\r\n" + Variables.FullPathAndNameDest);
                        stateDisplay.Text = "Intel Hex file written.";
                    }
                    else
                    {
                        MessageBox.Show("File write error","ERROR");
                        stateDisplay.Text = "File write error";
                    }


                }
            }
            
            
        }

       // Define the event handlers.
         
        private void button2_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Sigma Studio Hex File Converter Version 1.0 - 2015\r\nhttp://www.360customs.de\r\n\nBased on: 130232-I Sigma Studio Serial I²C EEPROM Programmer\r\nby Elektor International Media B.V.\r\n\nhttp://www.elektor-labs.com\r\n\nFree for non-commercial use.\r\n\nAll trademarks are the property of their respective owners. This software is provides as is. I accept no responsibility for any loss of data or harm.\r\n\nUSE AT YOUR OWN RISK!", "About", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }


        
    }
}